import fetch from 'utils/sagaCloudFetch'
import tools from 'utils/tools'
import { api, sass, img, physics, echarts } from 'api/config'


//获取label标签内容
export function getEquipmentLabel(
    code,
    projectId
) {
    return fetch({ method: 'GET', url: `${physics}/data-platform-3/infocode/query_property?projectId=${projectId}&type=${code}&enrich=true` })
        // return fetch({ method: 'GET', url: `${physics}/data-platform-3/infocode/query_property?type=${code}` })
}
//获取资产value内容
export function getEquipmentValue(
    FmId,
    projectId,
    secret
) {
    let data = {
            "criterias": [
                { "id": FmId }
            ]
        }
        // return fetch({ method: 'POST', url: `${echarts}/data-platform-3/object/batch_query?projectId=${projectId}&secret=${secret}`, data })
    return fetch({ method: 'POST', url: `${physics}/data-platform-3/property/id_query?projectId=${projectId}&secret=${secret}`, data })
}

//获取系统或岗位的value内容
export function getwinValue(
    id,
    projectId,
    secret
) {
    let data = {
        "customInfo":true,
        "criterias": [
            { "id": id }
        ]
    }
    console.log(data)
    return fetch({ method: 'POST', url: `${physics}/data-platform-3/infocode/complex_query?projectId=${projectId}&secret=${secret}`, data })
}

//通过分精度获取折线图
export function getEcharts(
    id,
    code,
    period,
    FmId,
    startTime,
    endTime,
    secret
) {
    let data = {
        'criteria': {
            'id': FmId, //perjectId
            'code': code, //搜索的字符
            'period': period, //搜索精度
            'receivetime': {
                '$gte': startTime, //搜索开始时间
                '$lt': endTime //搜索结束时间
            }
        }
    }

    return fetch({ method: 'POST', url: `${echarts}/data-platform-3/hisdata/query_period_data?projectId=${id}&secret=${secret}`, data })
}

//获取动态参数，暂停使用
export function getparameter(
    arr,
    perjectId,
    secret
) {
    let data = {
        "criterias": arr
    }
    return fetch({ method: 'POST', url: `${echarts}/data-platform-3/parameter/batch_query_param?projectId=${perjectId}&secret=${secret}`, data })
}

//获取表达式情况下的表号功能号

export function getMarkNumber(
    arr,
    perjectId,
    secret
) {
    let data = {
        "criterias": arr
    }
    return fetch({ method: 'POST', url: `${echarts}/data-platform-3/object/query_part_info?projectId=${perjectId}&secret=${secret}`, data })
}

export function getNoPeriod(
    id,
    code,
    FmId,
    startTime,
    endTime,
    secret
) {
    let data = {
        'criteria': {
            'id': FmId, //perjectId
            'code': code, //搜索的字符
            'receivetime': {
                '$gte': startTime, //搜索开始时间
                '$lt': endTime //搜索结束时间
            }
        }
    }

    return fetch({ method: 'POST', url: `${echarts}/data-platform-3/hisdata/query_by_obj?projectId=${id}&secret=${secret}`, data })
}

//修改接口
export function updateMess(param) {
    let data = {
        criterias: [{
            id: param.id,
            infos: param.data
        }]
    }
    console.log(JSON.stringify(data))
    return fetch({ method: 'POST', url: `${physics}/data-platform-3/object/batch_update?projectId=${param.perjectId}&secret=${param.secret}`, data })
}